YARD::Tags::Library.define_tag("For Gathering Scattered Components on One Page", :component)
YARD::Templates::Engine.register_template_path File.dirname(__FILE__) + '/../templates'

# Add a method to facilitate linking to components
module YARD::Templates::Helpers::BaseHelper
  alias_method :linkify_pre_yard_components, :linkify
  
  def linkify(*args)
    if args.first.is_a?(String) && args.first =~ /^component:(.*)/
      link_component($1)
    else
      linkify_pre_yard_components(*args)
    end
  end
  
  # @param [String] component_name
  def link_component(component_name)
    link_file("component-#{component_name}", component_name)
  end
end