include Helpers::ModuleHelper

def init
  super
  serialize_components
end

def generate_assets
  super
  generate_component_list
end

def generate_component_list
  @items = components.keys.sort
  @list_title = "Component List"
  @list_type = "components"
  asset('component_list.html', erb(:full_list))
end

def serialize_components
  components.each do |component_name, component_code_objects|
    options[:component] = {
      :name => component_name, 
      :code_objects => component_code_objects
    }
    options[:title] = "Component: #{component_name}"
    serialized_path = "file.component-#{component_name}.html"
    Templates::Engine.with_serializer(serialized_path, options[:serializer]) do
      T('layout').run(options)
    end
  end
end

def components
  return @components if @components
  @components = Hash.new{|h,k| h[k] = Hash.new{|h2, k2| h2[k2] = []}}
  Registry.each do |code_object|
    code_object.tags.select{|t| t.tag_name == 'component'}.each do |tag|
      if [:class, :module].include?(code_object.type)
        @components[tag.text][:classes_and_modules] << code_object
      else
        @components[tag.text][:other] << code_object
      end
    end
  end
  @components
end